/*
 * * * Compile_AHK SETTINGS BEGIN * * *

[AHK2EXE]
Exe_File=%In_Dir%\TopmostToggle.exe
No_UPX=1
[VERSION]
Set_Version_Info=1
File_Description=TopmostToggle
File_Version=1.9.2.0
Inc_File_Version=0
Legal_Copyright=2012 www.favessoft.com
Product_Name=TopmostToggle
Product_Version=1.9.2.0
[ICONS]
Icon_1=%In_Dir%\toptog.ico

* * * Compile_AHK SETTINGS END * * *
*/

;
; Topmost Toggle  v. 1.9.0.0
; Language:       English
; Platform:       Xp and later
; Author:         MilesAhead
;
; Script Function:
;	Toggle Topmost attribute of active window
;   by Control Right Clicking the mouse
;
; Toggle Alt-Tab visibility by Shift Right
; Click
;
; compile with latest AHK_L 32 bit Unicode build
;
#SingleInstance Ignore
#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
#include MilesAhead.ahk
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.
CoordMode,Mouse,Screen
Menu Tray,NoStandard
Menu Tray,Add,Donate,DoDonate
Menu Tray,Add,Visit Hotkey Page,DoVisit
Menu Tray,Add,Check for Update,DoCheck
Menu Tray,Add
Menu Tray,Add,About,DoAbout
Menu Tray,Add
Menu Tray,Add,Show Readme,DoReadme
Menu Tray,Add
Menu Tray,Add,Quit,DoQuit
if (A_IsCompiled)
  Menu Tray,Icon,%A_ScriptFullPath%,1
Menu Tray,Tip,Topmost Toggle
Menu Tray,Default,About
Menu Tray,Click,1
SetTitleMatchMode,RegEx

GroupAdd,SystemGroup, ahk_class Shell_TrayWnd
GroupAdd,SystemGroup, ahk_class DV2ControlHost
GroupAdd,SystemGroup, ahk_class Progman
GroupAdd,SystemGroup, ahk_class WorkerW

DumpMemory:
  _EmptyWorkingSet()
return

~LButton::
KillProgress:
  Progress,OFF
return

!RButton::
  ; toggle maximize button
  WinSet, Style, ^0x10000, A
  SetTimer,DumpMemory,-30000
return

#IfWinNotActive, ahk_group SystemGroup
^RButton::
  MouseGetPos,X,Y
  if (X > (A_ScreenWidth * .90))
    X -= 110
  WinGetTitle,title,A
  WinSet,Topmost,Toggle,A
  WinGet, ExStyle, ExStyle, A
  ; 0x8 is WS_EX_TOPMOST.
  if (ExStyle & 0x8)  
    Progress, zh0 B X%X% Y%Y% W110 fs10 C01 CTBlue,Topmost ON
  else
    Progress, zh0 B X%X% Y%Y% W110 fs10 C01 CTRed,Topmost OFF
  SetTimer,KillProgress,-5000
  SetTimer,DumpMemory,-30000
return

+RButton::
  ; toggle WS_EX_TOOLWINDOW
  WinSet, ExStyle, ^0x80, A
  WinGet, ExStyle, ExStyle, A
  ; set WS_EX_APPWINDOW accordingly
  if (ExStyle & 0x80)  
    WinSet, ExStyle, -0x00040000, A
  else
    WinSet, ExStyle, +0x00040000, A
  _EmptyWorkingSet()
return
  
DoDonate:
  Run,"http://www.favessoft.com/donate.html"
  SetTimer,DumpMemory,-30000
return

DoVisit:
  Run,"http://www.favessoft.com/hotkeys.html"
  SetTimer,DumpMemory,-30000
return

DoCheck:
  _CheckForUpdate()
  SetTimer,DumpMemory,-30000
return

DoAbout:
  if (AboutOpen)
    return
  AboutOpen := true
  FileGetVersion,filever,TopmostToggle.exe
  msg =
  (
Topmost Toggle %filever% Copyright (c)  %A_Year% www.FavesSoft.com`n
`nControl Right Click Mouse on active window to toggle Topmost
`nShift Right Click Mouse to toggle Atl-Tab visibility (toolbar style)
`nAlt Right Click Mouse to toggle Maximize Box
  )
  MsgBox,4096,Topmost Toggle,%msg%
  AboutOpen := false
  SetTimer,DumpMemory,-30000
return

DoReadme:
  Run,Readme.txt
  SetTimer,DumpMemory,-30000
return

DoQuit:
  ExitApp
